<?php
defined('IN_PHPCMS') or exit('No permission resources.');
//ģԭʹ洢·
define('MODEL_PATH',PC_PATH.'modules'.DIRECTORY_SEPARATOR.'yp'.DIRECTORY_SEPARATOR.'fields'.DIRECTORY_SEPARATOR);
//ģͻ·
define('CACHE_MODEL_PATH',CACHE_PATH.'caches_model'.DIRECTORY_SEPARATOR.'caches_data'.DIRECTORY_SEPARATOR);
pc_base::load_app_class('admin','admin',0);
class ypmodel extends admin {
	private $db;
	function __construct() {
		parent::__construct();
		$this->db = pc_base::load_model('sitemodel_model');
		$this->siteid = $this->get_siteid();
	}

	public function init() {
		$categorys = getcache('category_content_yp','yp');

		$datas = $this->db->listinfo("`type` IN ('4', '5')",'',$_GET['page'],30);
		//ģarray('ģid'=>);
		$items = array();
		foreach ($datas as $k=>$r) {
			$items[$r['modelid']] = 0;
			if (is_array($categorys)) {
				foreach ($categorys as $catid=>$cat) {
					if(intval($cat['modelid']) == intval($r['modelid'])) {
						$items[$r['modelid']] += intval($cat['items']);
					} else {
						$items[$r['modelid']] += 0;
					}
				}
			}
			$datas[$k]['tablename'] = str_replace('yp_', '', $r['tablename']);
			$datas[$k]['items'] = $items[$r['modelid']];
		}

		$pages = $this->db->pages;
		$this->public_cache();
		$show_header = true;
		$big_menu = array('javascript:window.top.art.dialog({id:\'add\',iframe:\'?m=yp&c=ypmodel&a=add\', title:\''.L('add_model').'\', width:\'700\', height:\'500\', lock:true}, function(){var d = window.top.art.dialog({id:\'add\'}).data.iframe;var form = d.document.getElementById(\'dosubmit\');form.click();return false;}, function(){window.top.art.dialog({id:\'add\'}).close()});void(0);', L('add_model'));
		include $this->admin_tpl('sitemodel_manage');
	}

	public function add() {
		if(isset($_POST['dosubmit'])) {
			$_POST['info']['siteid'] = $this->siteid;
			$_POST['info']['type'] = 5;
			$_POST['info']['tablename'] = $_POST['info']['tablename'] ? 'yp_'.$_POST['info']['tablename'] : showmessage(L('table_name_empty'));
			if ($_POST['info']['model_template']) $_POST['info']['category_template'] = $_POST['info']['model_template'];
			unset($_POST['info']['model_template']);
			$_POST['info']['setting'] = array2string($_POST['setting']);
			$modelid = $this->db->insert($_POST['info'],1);
			$model_sql = file_get_contents(MODEL_PATH.'model.sql');
			$tablepre = $this->db->db_tablepre;
			$tablename = $_POST['info']['tablename'];
			$model_sql = str_replace('$basic_table', $tablepre.$tablename, $model_sql);
			$model_sql = str_replace('$table_data',$tablepre.$tablename.'_data', $model_sql);
			$model_sql = str_replace('$table_model_field',$tablepre.'model_field', $model_sql);
			$model_sql = str_replace('$modelid',$modelid,$model_sql);
			$model_sql = str_replace('$siteid',$this->siteid,$model_sql);

			$this->db->sql_execute($model_sql);
			$this->cache_field($modelid);
			//ȫվӿ
			$this->type_db = pc_base::load_model('type_model');
			$this->type_db->insert(array('name'=>$_POST['info']['name'],'module'=>'search','modelid'=>$modelid,'siteid'=>$this->siteid));
			$cache_api = pc_base::load_app_class('cache_api','admin');
			$cache_api->cache('type');
			$cache_api->search_type();
			showmessage(L('add_success'), '', '', 'add');
		} else {
			pc_base::load_sys_class('form','',0);
			$show_header = $show_validator = '';
			$style_list = template_list($this->siteid, 0);
			foreach ($style_list as $k=>$v) {
				$style_list[$v['dirname']] = $v['name'] ? $v['name'] : $v['dirname'];
				unset($style_list[$k]);
			}
			include $this->admin_tpl('sitemodel_add');
		}
	}
	public function edit() {
		if(isset($_POST['dosubmit'])) {

			$modelid = intval($_POST['modelid']);
			if ($_POST['info']['model_template']) $_POST['info']['category_template'] = $_POST['info']['model_template'];
			unset($_POST['info']['model_template']);
			$_POST['info']['setting'] = array2string($_POST['setting']);

			$this->db->update($_POST['info'],array('modelid'=>$modelid,'siteid'=>$this->siteid));
			showmessage(L('update_success'), '', '', 'edit');
		} else {
			pc_base::load_sys_class('form','',0);
			$show_header = $show_validator = '';
			$style_list = template_list($this->siteid, 0);
			foreach ($style_list as $k=>$v) {
				$style_list[$v['dirname']] = $v['name'] ? $v['name'] : $v['dirname'];
				unset($style_list[$k]);
			}
			$modelid = intval($_GET['modelid']);
			$r = $this->db->get_one(array('modelid'=>$modelid));
			extract($r);
			$setting = string2array($setting);
			$tablename = str_replace('yp_', '', $tablename);
			include $this->admin_tpl('sitemodel_edit');
		}
	}
	public function delete() {
		$this->sitemodel_field_db = pc_base::load_model('sitemodel_field_model');
		$modelid = intval($_GET['modelid']);
		$model_cache = getcache('yp_model','model');
		$model_table = $model_cache[$modelid]['tablename'];
		$this->sitemodel_field_db->delete(array('modelid'=>$modelid,'siteid'=>$this->siteid));
		$this->db->drop_table($model_table);
		$this->db->drop_table($model_table.'_data');

		$this->db->delete(array('modelid'=>$modelid,'siteid'=>$this->siteid));
		//ɾȫվӿ
		$this->type_db = pc_base::load_model('type_model');
		$this->type_db->delete(array('module'=>'search','modelid'=>$modelid,'siteid'=>$this->siteid));
		$cache_api = pc_base::load_app_class('cache_api','admin');
		$cache_api->cache('type');
		$cache_api->search_type();
		exit('1');
	}
	public function disabled() {
		$modelid = intval($_GET['modelid']);
		$r = $this->db->get_one(array('modelid'=>$modelid,'siteid'=>$this->siteid));

		$status = $r['disabled'] == '1' ? '0' : '1';
		$this->db->update(array('disabled'=>$status),array('modelid'=>$modelid,'siteid'=>$this->siteid));
		showmessage(L('update_success'), HTTP_REFERER);
	}
	/**
	 * ģͻ
	 */
	public function public_cache() {
		require MODEL_PATH.'fields.inc.php';
		//PHPCMSҵҳլ޸İ棩⡢¡
		$classtypes = array('form','input','update','output');
		foreach($classtypes as $classtype) {
			$cache_data = file_get_contents(MODEL_PATH.'yp_'.$classtype.'.class.php');
			$cache_data = str_replace('}?>','',$cache_data);
			foreach($fields as $field=>$fieldvalue) {
				if(file_exists(MODEL_PATH.$field.DIRECTORY_SEPARATOR.$classtype.'.inc.php')) {
					$cache_data .= file_get_contents(MODEL_PATH.$field.DIRECTORY_SEPARATOR.$classtype.'.inc.php');
				}
			}
			$cache_data .= "\r\n } \r\n?>";
			file_put_contents(CACHE_MODEL_PATH.'yp_'.$classtype.'.class.php',$cache_data);
			@chmod(CACHE_MODEL_PATH.'yp_'.$classtype.'.class.php',0777);
		}
		//ģݻ
		$model_array = array();
		$datas = $this->db->select(array('type'=>5));
		foreach ($datas as $r) {
			if(!$r['disabled']) $model_array[$r['modelid']] = $r;
		}
		setcache('yp_model', $model_array, 'model');
		return true;
	}
	//ҳģRewrite
	public function public_rewriteurl() {
		$yp_model = getcache('yp_model', 'model');
		$modelids = array_keys($yp_model);
		$apache_rewriteurl  = $iis_rewriteurl = '';
		if(is_array($modelids)) foreach($modelids as $m) {
			$setting = string2array($yp_model[$m]['setting']);
			if ($setting['ismenu'] == 0) continue;
			$rewriteurl_1 = 'yp-list-([0-9]+)-(.*)-';
			$iis_rewriteurl_1 = '(.*)/yp\-list\-([0-9]+)\-(.*)\-';
			$rewriteurl_2 = 'index.php?m=yp&c=index&a=lists&modelid=$1';
			$iis_rewriteurl_2 = '$1/index\.php\?m=yp&c=index&a=lists&modelid=$2';
			$num = 2;
			$fields = getcache('model_field_'.$m,'model');
			if(is_array($fields) && !empty($fields)) {
				ksort($fields);
				foreach ($fields as $_v=>$_k) {
					if($_k['filtertype'] || $_k['rangetype']) {
						$rewriteurl_1 .= '(.*)-';
						$iis_rewriteurl_1 .= '(.*)\-';
						$rewriteurl_2 .= '&'.$_v.'=$'.$num ;
						$iis_rewriteurl_2 .= '&'.$_v.'=$'.intval($num+1) ;
						$num ++;
					}
				}
				$rewriteurl_1 .= '([0-9]+).html';
				$iis_rewriteurl_1 .= '([0-9]+)\.html\?*(.*)$';
				$rewriteurl_2 .= '&page=$'.$num;
				$iis_rewriteurl_2 .= '&page=$'.$num;
				$apache_rewriteurl .= 'RewriteRule ^'.$rewriteurl_1.'   '.$rewriteurl_2."\n";
				$iis_rewriteurl .= 'RewriteRule ^'.$iis_rewriteurl_1.'   '.$iis_rewriteurl_2."\n";
			}
		}
		$ng_rewriteurl .= "if (!-e \$request_filename) {\n\treturn 404;\n}";
		$show_header = 1;
		include $this->admin_tpl('rewriteurl');
	}
	/**
	 * ģ
	 */
	function export() {
		$modelid = isset($_GET['modelid']) ? $_GET['modelid'] : showmessage(L('illegal_parameters'), HTTP_REFERER);
		$modelarr = getcache('yp_model', 'model');
		//ϵͳֶų
		//$system_field = array('id','title','style','catid','url','listorder','status','userid','username','inputtime','updatetime','pages','readpoint','template','groupids_view','posids','content','keywords','description','thumb','typeid','relation','islink','allow_comment');
		$this->sitemodel_field_db = pc_base::load_model('sitemodel_field_model');
		$modelinfo = $this->sitemodel_field_db->select(array('modelid'=>$modelid));
		foreach($modelinfo as $k=>$v) {
			//if(in_array($v['field'],$system_field)) continue;
			$modelinfoarr[$k] = $v;
			$modelinfoarr[$k]['setting'] = string2array($v['setting']);
		}
		$res = var_export($modelinfoarr, TRUE);
		header('Content-Disposition: attachment; filename="'.$modelarr[$modelid]['tablename'].'.model"');
		echo $res;exit;
	}
	/**
	 * ģ
	 */
	function import(){
		if(isset($_POST['dosubmit'])) {
			$info = array();
			$info['name'] = $_POST['info']['modelname'];
			//
			$basic_table = $info['tablename'] = $_POST['info']['tablename'];
			//ӱ
			$table_data = $basic_table.'_data';
			$info['description'] = $_POST['info']['description'];
			$info['type'] = 5;
			$info['siteid'] = $this->siteid;

			$info['default_style'] = $_POST['default_style'];
			$info['category_template'] = $_POST['setting']['category_template'];
			$info['list_template'] = $_POST['setting']['list_template'];
			$info['show_template'] = $_POST['setting']['show_template'];

			if(!empty($_FILES['model_import']['tmp_name'])) {
				$model_import = @file_get_contents($_FILES['model_import']['tmp_name']);
				if(!empty($model_import)) {
					$model_import_data = string2array($model_import);
				}
			}
			$is_exists = $this->db->table_exists($basic_table);
			if($is_exists) showmessage(L('operation_failure'),'?m=yp&c=ypmodel&a=init');
			$modelid = $this->db->insert($info, 1);
			if($modelid){
				$tablepre = $this->db->db_tablepre;
				//ݱ
				$model_sql = file_get_contents(MODEL_PATH.'model.sql');
				$model_sql = str_replace('$basic_table', $tablepre.$basic_table, $model_sql);
				$model_sql = str_replace('$table_data',$tablepre.$table_data, $model_sql);
				$model_sql = str_replace('$table_model_field',$tablepre.'model_field', $model_sql);
				$model_sql = str_replace('$modelid',$modelid,$model_sql);
				$model_sql = str_replace('$siteid',$this->siteid,$model_sql);
				$this->db->sql_execute($model_sql);

				if(!empty($model_import_data)) {
					$this->sitemodel_field_db = pc_base::load_model('sitemodel_field_model');
					$system_field = array('title','style','catid','url','listorder','status','userid','username','inputtime','updatetime','pages','readpoint','template','groupids_view','posids','content','keywords','description','thumb','typeid','relation','islink','allow_comment');

					foreach($model_import_data as $v) {
						$field = $v['field'];
						if(in_array($field,$system_field)) {
							$v['siteid'] = $this->siteid;
							unset($v['fieldid'],$v['modelid'],$v['field']);
							$v = new_addslashes($v);
							$v['setting'] = array2string($v['setting']);

							$this->sitemodel_field_db->update($v,array('modelid'=>$modelid,'field'=>$field));
						} else {
							$tablename = $v['issystem'] ? $tablepre.$basic_table : $tablepre.$table_data;
							//ģͱֶ

							$minlength = $v['minlength'] ? $v['minlength'] : 0;
							$maxlength = $v['maxlength'] ? $v['maxlength'] : 0;
							$field_type = $v['formtype'];
							require MODEL_PATH.$field_type.DIRECTORY_SEPARATOR.'config.inc.php';
							if(isset($v['setting']['fieldtype'])) {
								$field_type = $v['setting']['fieldtype'];
							}
							require MODEL_PATH.'add.sql.php';
							$v['tips'] = addslashes($v['tips']);
							$v['setting'] = array2string($v['setting']);
							$v['modelid'] = $modelid;
							$v['siteid'] = $this->siteid;
							unset($v['fieldid']);

							$this->sitemodel_field_db->insert($v);
						}
					}
				}
				$this->public_cache();
				showmessage(L('operation_success'),'?m=yp&c=ypmodel&a=init');
			}
		} else {
			pc_base::load_sys_class('form','',0);
			$show_validator = '';
			$show_header = true;
			$style_list = template_list($this->siteid, 0);
			foreach ($style_list as $k=>$v) {
				$style_list[$v['dirname']] = $v['name'] ? $v['name'] : $v['dirname'];
				unset($style_list[$k]);
			}
			$big_menu = array('javascript:window.top.art.dialog({id:\'add\',iframe:\'?m=yp&c=ypmodel&a=add\', title:\''.L('add_model').'\', width:\'580\', height:\'400\', lock:true}, function(){var d = window.top.art.dialog({id:\'add\'}).data.iframe;var form = d.document.getElementById(\'dosubmit\');form.click();return false;}, function(){window.top.art.dialog({id:\'add\'}).close()});void(0);', L('add_model'));
			include $this->admin_tpl('sitemodel_import');
		}
	}
	/**
	 * Ƿ
	 */
	public function public_check_tablename() {
		if ($_GET['tablename']) {
			$tablename = 'yp_'.$_GET['tablename'];
		} else {
			exit('0');
		}
		$r = $this->db->table_exists(strip_tags($tablename));
		if(!$r) echo '1';
	}
	/**
	 * ָģֶλ
	 *
	 * @param $modelid ģid
	 */
	public function cache_field($modelid = 0) {
		$this->field_db = pc_base::load_model('sitemodel_field_model');
		$field_array = array();
		$fields = $this->field_db->select(array('modelid'=>$modelid,'disabled'=>$disabled),'*',100,'listorder ASC');
		foreach($fields as $_value) {
			$setting = string2array($_value['setting']);
			$_value = array_merge($_value,$setting);
			$field_array[$_value['field']] = $_value;
		}
		setcache('model_field_'.$modelid,$field_array,'model');
		return true;
	}
}
?>